/*
    Copyright 2010 Luis Miguel Merino Bonilla

    This file is part of GNU Taste

    GNU Taste is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GNU Taste is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with GNU Taste. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __PEARSON__
#define __PEARSON__

#include <cmath>
#include "database.h"
#include "feature_vector.h"

float adjustedCosine(feature_vector *a, feature_vector *b, Database *db){
	//Calcula el coseno ajustado entre dos vectores
	// * Hay que revisar qué hacer en el caso de que la intersección
	//   no sea vacía, y la sumatoria de ratings sea cero 

	node *n = a->begin();
	node *m = b->begin();

	float sim=0, dev_u=0, dev_v=0;

	while(n != 0 && m != 0){
		if(m->id < n->id){
			m=ne(m);
		} else if(m->id == n->id){
			sim += m->value*n->value;
			dev_u += m->value*m->value;
			dev_v += n->value*n->value;
			m=ne(m);
			n=ne(n);
		} else {
			n=ne(n);
		}
	}
		
	if(dev_u > 0 && dev_v > 0)
		return sim / sqrt(dev_u*dev_v);
	else 
		return 0;
		
};

/*
float adjustedCosine(feature_vector *a, feature_vector *b, Database *db){
	//Calcula el coseno ajustado entre dos vectores
	// * Hay que revisar qué hacer en el caso de que la intersección
	//   no sea vacía, y la sumatoria de ratings sea cero 

	node *n = a->begin();
	node *m = b->begin();

	float sim=0, dev_u=0, dev_v=0;

	while(n != 0 && m != 0){
		if(m->id < n->id){
			m=ne(m);
		} else if(m->id == n->id){
			float mm = m->value - db->getMean(m->id);
			float nn = n->value - db->getMean(n->id);
			sim += mm*nn;
			dev_u += mm*mm;
			dev_v += nn*nn;
			m=ne(m);
			n=ne(n);
		} else {
			n=ne(n);
		}
	}
		
	if(dev_u > 0 && dev_v > 0)
		return sim / sqrt(dev_u*dev_v);
	else 
		return 0;
		
};
*/
#endif
