/*
    Copyright 2010 Luis Miguel Merino Bonilla

    This file is part of GNU Taste

    GNU Taste is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GNU Taste is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with GNU Taste. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __PEARSON__
#define __PEARSON__

#include <cmath>
#include "feature_vector.h"


float pearson(feature_vector *a, feature_vector *b, float meanU, float meanV){
	node *n = a->begin();
	node *m = b->begin();

	//cout << "jarl" << endl;

	float sim=0, dev_u=0, dev_v=0;
	int i=0;
	
	while(n != 0 && m != 0){
		if(m->id < n->id)
			m=ne(m);
		else if(m->id == n->id){
			sim += m->value * n->value;
			dev_u += m->value * m->value;
			dev_v += n->value * n->value;
			m=ne(m);
			n=ne(n);
			++i;
		} else
			n=ne(n);
	}
	
	if(i >= 50)
		return sim / (sqrt(dev_u*dev_v));
	else if (i > 0)
		return sim / (sqrt(dev_u*dev_v)) * i/50;
	else 
		return 0;
		
};


/*
float pearson(feature_vector *a, feature_vector *b, float meanU, float meanV){
	node *n = a->begin();
	node *m = b->begin();

	//cout << "jarl" << endl;

	float sim=0, dev_u=0, dev_v=0;
	int i=0;
	
	while(n != 0 && m != 0){
		//cout << m->id<<":"<<m->value << " " <<n->id<<":"<<n->value << endl;
		if(m->id < n->id)
			m=ne(m);
		else if(m->id == n->id){
			sim += (m->value-meanU) * (n->value-meanV);
			dev_u += (m->value-meanU) * (m->value-meanU);
			dev_v += (n->value-meanV) * (n->value-meanV);
			m=ne(m);
			n=ne(n);
			++i;
		} else
			n=ne(n);
	}
	
	if(i >= 50)
//	if(i > 0)
		return sim / (sqrt(dev_u*dev_v));
	else if (i > 0)
		return sim / (sqrt(dev_u*dev_v)) * i/50;
	else 
		return 0;
		
};
*/

#endif
