/*
    Copyright 2010 Luis Miguel Merino Bonilla

    This file is part of GNU Taste

    GNU Taste is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GNU Taste is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with GNU Taste. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __STORAGE__
#define __STORAGE__

#include "feature_vector.h"
#include "log.h"
#include <fstream>

class Storage{
private:
public:
	feature_vector * loadFeatureVector(char *fname){
		ifstream i;
		
		feature_vector *f = new feature_vector();
		i.open(fname);
		if(!i.fail())
			i >> *f;
		i.close();

		return f;
	}

	feature_vector * saveFeatureVector(char *fname, feature_vector &f){
		ofstream o;
		o.open(fname);
		o << f;
		o.close();
	}

	void loadHash(char *fname, Serializable &f){
		ifstream i;
		i.open(fname);
		if(!i.fail())
			i >> f;
		i.close();
	}

	void saveHash(char *fname, Serializable &f){
		ofstream o;
		o.open(fname);
		o << f;
		o.close();
	}

	feature_vector * loadProfile(int id){
		char fname[64];
		sprintf(fname, "data/user/%d.ratings", id);
		return loadFeatureVector(fname);
	}


	void saveProfile(int id, feature_vector &f){
		char fname[64];
		sprintf(fname, "data/user/%d.ratings", id);
		saveFeatureVector(fname,f); 
	}

	feature_vector * loadItem(int id){
		char fname[64];
		sprintf(fname, "data/item/%d.ratings", id);
		return loadFeatureVector(fname);
	}

	void saveItem(int id, feature_vector &f){
		char fname[64];
		sprintf(fname, "data/item/%d.ratings", id);
		saveFeatureVector(fname,f); 
	}

	Hash<float> * loadSimilarity(int u){
		char fname[64];
		ifstream i;
		
		Hash<float> * f = new Hash<float> ();

/*
		sprintf(fname, "model/%d.ratings", u);
		i.open(fname);
		if(!i.fail())
			i >> *f;
		i.close();
*/
		return f;

	}
};

#endif
